## DEFINE environments 
MPI=
GROMPP=
MDRUN=
TOP=
t0=md000
rep0=`awk '{x=$1}END{print x}' "./tracing_temperature.dat"`

time=1
d=500000  ## simulation time=d*delta t

while [ $time -le $d ]; do 

tt=`awk -v c=$time 'BEGIN{printf "md%07d", c}'`

## Define temperature for next run and update the weight parameters
if [ $time -eq 1 ];
then
 rep=1
 mdp=md1s.mdp ## md1s.mdp: "genvel=yes"
else
 pot=`awk '{pot[NR]=$1}END{print pot[FNR]}' "./potential/pot_${rep0}.dat"`
 rep=`awk -v rep0=$rep0 -v pot=$pot -v seed1=$RANDOM -v seed2=$RANDOM 'BEGIN{
 while(getline < "beta.dat" )
 {
  for(i=1;i<=NF;i++){count++;beta[i]=$i}
 }
 while(getline < "./average_pot.dat")
 {
  for(i=1;i<=count;i++){aver_pot[i]=$i}
 }
}
{
 for(i=1;i<=count;i++){weight[i]=$i}
}
END{
 for(i=2;i<=count;i++)
  {
   weight[i]=weight[i-1]+(beta[i]-beta[i-1])*(aver_pot[i]+aver_pot[i-1])/2
  }
 {
  srand(seed2);
  direct=rand()
  if((rep0>1)&&(rep0<count))
   {
   if(direct>=0.5){factor=-1}
   else{factor=1}
   }
  else if(rep0==1)
   {
   if(direct>=0.5){factor=0}
   else{factor=1}
   }
  else if(rep0==count)
    {
    if(direct>=0.5){factor=-1}
    else{factor=0}
    }
  }
  P_ex=exp(-((beta[rep0+factor]-beta[rep0])*pot-(weight[rep0+factor]-weight[rep0])))
   srand(seed1);
   rdnum=rand()
   if(P_ex>=rdnum){rep=rep0+factor}
   else{rep=rep0}

print rep

for(i=1;i<=count;i++)
 {
  printf "%15.8f", weight[i] >> "./weight.dat"
 }
printf "\n" >> "./weight.dat"
}' "/weight.dat"`  ## exchange.sh: update weight, and determine next temperature. 
 mdp=md${rep}.mdp  ## md${rep}.mdp: "genvel=no"
fi

##velocity rescale
cp ./gro/$t0.gro ./gro/$t0.gro.BACK
awk -v bef=$rep0 -v aft=$rep 'BEGIN{
while(getline < "ALL_temperature.dat" > 0)
 {
  count++
  temp[count]=$2
 }
 factor=sqrt(temp[aft]/temp[bef])
}
{
if((NF>=8)&&(($2+0)!=$2))
 {
  others=substr($0,1,44)
  vx=substr($0,45,8)*factor
  vy=substr($0,54,8)*factor
  vz=substr($0,63,8)*factor
  printf "%44s%8.4f%8.4f%8.4f\n", others, vx, vy, vz
 }
else{print $0}	 
}' ./gro/$t0.gro.BACK > ./gro/$t0.gro
rm ./gro/$t0.gro.BACK

echo $rep >> tracing_temperature.dat

## RUN
$GROMPP -f $mdp -c ./gro/$t0 -p $TOP -o ./tpr/$tt -maxwarn 2 > /dev/null
rm mdout.mdp
$MPI -np 16 $MDRUN -s ./tpr/${tt}.tpr -c ./gro/$tt -g ./log/$tt -x ./xtc/$tt > /dev/null 
rm *.trr *.cpt *.edr 

## EXTRACT the potential energy for calculation of weight

awk 'BEGIN{
count=0
}
{
for(i=1;i<=8;i++)
 {
  if($1=="<===="){exit}
  else
  {
   k=15*(i-1)+1
   term=substr($0,k,15)
   if(term=="      Potential")
   {
    count++
    getline
    pot[count]=substr($0,k,15)
   }
  }
 }
}
END{
for(i=2;i<=count;i++)
 {
  printf "%15.5f\n", pot[i]
 }
}' ./log/${tt}.log >> ./potential/pot_${rep}.dat

## calculate averaged potential
c=1
d=`awk 'END{print FNR}' "./ALL_temperature.dat"`
rm average_pot.dat
while [ $c -le $d ]; do
 fin=./potential/pot_${c}.dat
if [ -f $fin ]; then
 aver_pot=`awk '{tot=tot+$1}END{print tot/FNR}' $fin`
 printf "%15.3f" $aver_pot >> "./average_pot.dat"
else
 printf "%15.3f" $aver_pot >> "./average_pot.dat"
fi

let c=c+1
done

t0=$tt
rep0=$rep

let time=time+1
done